let inputs = $('.game-coininput');

const el = document.querySelectorAll('.bet-button');
const body = document.querySelectorAll('body');
const gameBox = document.querySelectorAll('.game-area');
let isActive = false;
let inputsFilled = false;

// elements & markup
const modalBox = document.createElement("div");
modalBox.classList.add('ft-modal');
modalBox.classList.add('hidden');
const modalInner = document.createElement("div");
modalInner.innerHTML = '<label>Amount:</label><input class="ft-form__amount" type="text" value="0.001" /></br><label>Stop on Loss:</label><input class="ft-form__stoploss" type="text" value="0.00" /></br><label>Increase on Win:</label><input class="ft-form__incwin" type="text" value="26.9955" /></br><label>Payout:</label><input class="ft-form__payout" type="text" value="9.9397" /></br><button class="ui-button button-small s-conic ft-save"><div class="button-inner">Save Settings</div></button><div class="ft-close-modal">X</div>';
modalBox.appendChild(modalInner);

const boxOuter = document.createElement("div");
const boxInner = document.createElement("div");
const span1 = document.createElement("span");
const span2 = document.createElement("span");
const span3 = document.createElement("span");
const span4 = document.createElement("span");
span1.classList.add('ft-text');
span1.innerHTML = '<i class="fa fa-gamepad">'
span2.classList.add('ft-tankie');
span2.innerHTML = '<i class="fa fa-times-circle">'
span3.classList.add('ft-doubler');
span3.innerHTML = '💣'
span4.classList.add('ft-mod');
span4.innerHTML = '<i class="fa fa-cog">'
boxInner.appendChild(span1);
boxInner.appendChild(span2);
boxInner.appendChild(span3);
boxInner.appendChild(span4);
boxOuter.append(boxInner);
boxOuter.classList.add('ft-barrr');

// ADD NEW DOM ELEMENTS
el[0].after(boxOuter);
gameBox[0].appendChild(modalBox);

const EVENT_OPTIONS = {bubbles: true, cancelable: false, composed: true};
const EVENTS = {
    BLUR: new Event("blur", EVENT_OPTIONS),
    CHANGE: new Event("change", EVENT_OPTIONS),
    INPUT: new Event("input", EVENT_OPTIONS),
};

// fishy logo: https://cdn.discordapp.com/icons/897880871779041301/790b42d9f50b651cb726fe605fc2014d.webp?size=48



// trigger 'live stats' modal
if (!document.querySelectorAll('.game-actions .action-item')[1].classList.contains('active')){
	document.querySelectorAll('.game-actions .action-item')[1].click();
}

// in order to trigger a value change in React, you have to bypass the custom value setter that is added 
// by the framework on the HTMLInputElement instance, which overrides the one from HTMLInputElement. prototype 
// (the native one). Once you've done that, emit an input event to notify the framework that the value has changed, 
// for correct taking into account by the framework.
function setNativeValue(element, value) {
  const valueSetter = Object.getOwnPropertyDescriptor(element, 'value').set;
  const prototype = Object.getPrototypeOf(element);
  const prototypeValueSetter = Object.getOwnPropertyDescriptor(prototype, 'value').set;

  if (valueSetter && valueSetter !== prototypeValueSetter) {
    prototypeValueSetter.call(element, value);
  } else {
    valueSetter.call(element, value);
  }
}

let timer;
let timerDoubler;

function start(){
	document.getElementsByClassName('ft-text')[0].classList.add('active');
	setTimeout(document.querySelectorAll('.slider-handles input')[0].removeAttribute('disabled'), 2000);
	time();
}

function startDoubler(ev){
	console.log(ev);
	ev.cancelBubble = true;
	ev.bubbles = false;
	ev.preventDefault();
    ev.stopPropagation();
	if (document.getElementsByClassName('ft-doubler')[0].classList.contains('active')){
		document.getElementsByClassName('ft-doubler')[0].classList.remove('active');
		doublerStop();
	} else {
		document.getElementsByClassName('ft-doubler')[0].classList.add('active');
		doublerStart();
	}
	
}

//const inputHandler = function(e) {
  //document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].value = '0.0001';
//}
//const inputBlurHandler = function(e) {
  //document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].value = '0.0001';
//}

//document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].addEventListener('change', inputHandler);
//document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].addEventListener('blur', inputBlurHandler);

function doublerStart(){
	timerDoubler=setTimeout(function(){
		document.querySelectorAll('.button-group')[0].querySelectorAll('button')[1].click();
		doublerStart();
	}, 750);
}

function doublerStop(){
	clearTimeout(timerDoubler);
	document.getElementsByClassName('ft-doubler')[0].classList.remove('active');
}

function time(){
	isActive = true;
	timer=setTimeout(function(){
    
				// set all values
				//document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].value = '0.0001';
				
				//let input = document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0]; 
				//let lastValue = input.value;
				//let event = new Event('change', { bubbles: true });
				// hack React15
				//event.simulated = true;
				// hack React16 内部定义了descriptor拦截value，此处重置状态
				//let tracker = input._valueTracker;
				//if (tracker) {
					//tracker.setValue(lastValue);
				//}
				//input.dispatchEvent(event);

				//document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].setAttribute('value','0.000640');
				
				//document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[2].querySelectorAll('input')[0].value = '26.9955';
				//document.querySelectorAll('.game-control-panel')[0].querySelectorAll('.input-control')[3].querySelectorAll('input')[0].value = '0.01';
				//document.querySelectorAll('.turbo-bet')[0].querySelectorAll('.input-control')[0].querySelectorAll('input')[0].value = '9.9397';
				//document.querySelectorAll('.turbo-bet')[0].querySelectorAll('.input-control')[1].querySelectorAll('input')[0].value = '9.96';
				//document.querySelectorAll('.turbo-bet')[0].querySelectorAll('.input-control')[2].querySelectorAll('input')[0].value = '9.96';
				//document.querySelectorAll('.turbo-bet')[0].querySelectorAll('.slider-handles input')[0].value = '9.9397';

			const profitStatusElement = document.querySelectorAll('.item-wrap.profit :nth-child(2)')[0];
			const profitStatus = profitStatusElement.classList.contains('cl-require');
			
			document.querySelectorAll('.slider-handles input')[0].removeAttribute('disabled');

			// on win checkbox
			if(document.querySelectorAll('.increase-switch')[0].classList.contains('is-enable')){
				document.querySelectorAll('.increase-switch')[0].click();
			}
	
			// on lose checkbox
			if(profitStatus && document.querySelectorAll('.increase-switch')[1].classList.contains('is-enable')){
				document.querySelectorAll('.increase-switch')[1].click();
			} else if (!profitStatus && !document.querySelectorAll('.increase-switch')[1].classList.contains('is-enable')) {
				document.querySelectorAll('.increase-switch')[1].click();
			}
	
			// auto start the shit
			if (document.querySelectorAll('.bet-button .button-inner')[0].innerHTML === 'Start Auto Bet'){
				console.log('boom');
				// trigger start button click
				document.querySelectorAll('.bet-button .button-inner')[0].click();
			}

			// enable all shit
			if (inputs.classList.contains('is-disabled')){
				inputs.classList.remove('is-disabled');
				var collection = document.querySelectorAll('.input-control input');

				for (var i = 0; i < collection.length; i++) {
					collection[i].removeAttribute('disabled');
				}

				var collection2 = document.querySelectorAll('.ui-input.is-disabled');
				for (var i = 0; i < collection2.length; i++) {
					collection2[i].classList.remove('is-disabled');
				}
			}

			let profitValue = document.querySelectorAll('.cl-success .amount .amount-str')[0];
			// let lossValue = document.querySelectorAll('.cl-require .amount .amount-str')[0];

			if (profitValue) {
				// detect if we are in profit so we can just check for a truthy value
				if (parseFloat(profitValue.innerText) > 100) {
  				// stop the auto betting by triggering a click on the button
  					document.querySelectorAll('.title-btn')[0].click();
				}
			}

    time();
  }, 1200);
}

function stop(){
	isActive = false;
	clearTimeout(timer);
	document.querySelectorAll('.bet-button .button-inner')[0].click();
	document.getElementsByClassName('ft-text')[0].classList.remove('active');
}

function openModal(ev) {
	console.log('open', ev);
	ev.preventDefault();
    ev.stopPropagation();
	document.querySelectorAll('.ft-modal')[0].classList.remove('hidden');
}

function closeModal(ev) {
	console.log('close', ev);
	ev.preventDefault();
    ev.stopPropagation();
	document.querySelectorAll('.ft-modal')[0].classList.add('hidden');
}

function saveModal(ev) {
	
	console.log('close', ev);
	console.log('savings changes...probably...');
	ev.preventDefault();
    ev.stopPropagation();
	
	let amount = document.querySelectorAll('.ft-form__amount')[0].value;
	let incWin = document.querySelectorAll('.ft-form__incwin')[0].value;
	let stopLoss = document.querySelectorAll('.ft-form__stoploss')[0].value;
	let payout = document.querySelectorAll('.ft-form__payout')[0].value;
	
	document.querySelectorAll('.ft-modal')[0].classList.add('hidden');
	
	//document.querySelectorAll('.input-control input')[0].value = amount;
	if(document.querySelectorAll('.increase-switch')[0].classList.contains('is-enable')) {
		document.querySelectorAll('.increase-switch')[0].click();
	}
	
	const el0 = document.querySelectorAll('.input-control input')[0];
    setNativeValue(el0, amount);
    el0.dispatchEvent(new Event('input', { bubbles: true }));
	document.querySelectorAll('.input-control input')[0].focus();
	
	const el1 = document.querySelectorAll('.input-control input')[2];
    setNativeValue(el1, incWin);
    el1.dispatchEvent(new Event('input', { bubbles: true }));
	document.querySelectorAll('.input-control input')[2].focus();
	
	const el2 = document.querySelectorAll('.input-control input')[5];
    setNativeValue(el2, stopLoss);
    el2.dispatchEvent(new Event('input', { bubbles: true }));
	document.querySelectorAll('.input-control input')[5].focus();
	
	const el3 = document.querySelectorAll('.input-control input')[6];
    setNativeValue(el3, payout);
    el3.dispatchEvent(new Event('input', { bubbles: true }));
	document.querySelectorAll('.input-control input')[6].focus();
	
	//document.querySelectorAll('.input-control input')[6].value = '9.9397';
	//document.querySelectorAll('.input-control input')[7].value = '9.96';
	//document.querySelectorAll('.input-control input')[8].value = '9.96';
	
	//document.querySelectorAll('.roll-switch .input-control input')[0].value = '9.9397';
	//document.querySelectorAll('.drag-block')[0].value = '9.96';
	//document.querySelectorAll('.input-control input')[6].value = '9.9397';
	//document.querySelectorAll('.win-change input')[0].value = '9.96';
	
	
	
}

// ==========================================================================
// CLICK EVENTS ===================================================================
// ==========================================================================

// START BUTTON 1 -> start autobetting
let btnStart = document.getElementsByClassName('ft-text')[0];
btnStart.addEventListener("click", start, false);

// STOP BUTTON 2 -> stop autobetting
let btnStop = document.getElementsByClassName('ft-tankie')[0];
btnStop.addEventListener("click", stop, false);

// TOGGLE BUTTON 3 -> amount doubler function (risky)
let btnStartDoubler = document.getElementsByClassName('ft-doubler')[0];
btnStartDoubler.addEventListener("click", startDoubler, false);

// START BUTTON 4 -> options modal
let btnModal = document.getElementsByClassName('ft-mod')[0];
btnModal.addEventListener("click", openModal, false);

// MODAL -> close modal
document.getElementsByClassName('ft-close-modal')[0].addEventListener('click', closeModal, false);

// MODAL -> save modal
document.getElementsByClassName('ft-save')[0].addEventListener('click', saveModal, false);

// ==========================================================================
// STYLES ===================================================================
// ==========================================================================

const style = document.createElement('style');

style.textContent = `
	.game-area {
		position: relative;
	}

  .ft-barrr {
    background-color: white;
    border-radius: 12px;
    height: 60px;
    width: 90%;
    text-align: center;
    margin: 0 auto;
    margin-top: 80px;
    background-image: conic-gradient(from 1turn,#43b309,#5ddb1c);
    position: relative;
  }

.ft-barrr > div {
	height: 100%;
	margin-top: -80px;
}

.ft-barrr .ft-tooltip {
	position: absolute;
    z-index: 9999;
    color: #fff;
    top: 18px;
    left: 40%;
    font-size: 20px;
}

.ft-text, .ft-tankie, .ft-doubler, .ft-mod{
	transition: all 0.25s ease-in-out;
    margin-left: 4px;
    font-size: 40px;
    line-height: 55px;
    height: 60px;
    border-radius: 9px;
    padding: 0 10px;
    border: 1px solid transparent;
    display: inline-block;
    color: #fff;
}

.ft-text {
	color: #581ac4;
	height: 52px;
}

.ft-text i {
	font-size: 46px;
}

.ft-tankie {
	color: #e11b1b;
}

.ft-doubler {
	font-size: 30px;
    vertical-align: super;
	border-radius: 0;
}

.ft-text:hover, .ft-tankie:hover, .ft-doubler:hover, .ft-mod:hover {
	color: #581ac4;
	font-weight: bold;
	cursor: pointer;
}

.ft-text:hover {
	color: #039308!important;
}
.ft-text.active {
	color: #fff!important;
}

.ft-doubler:hover {
	background-color: #31343c!important;
	text-shadow: 6px 4px #fff;
}
.ft-mod:hover {
	color: #edf108!important;
}

.ft-text.active, .ft-doubler.active {
	background-image: conic-gradient(from 1turn,#581ac4,#773cfd);
}

.ft-modal {
	display: flex;
	position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: black;
    z-index: 999999999;
	color: #fff;
	padding: 0 15%;
	border-radius: 20px;
}

.ft-modal.hidden {
	display: none!important;
}

.ft-modal > div {
	margin: 0 auto;
    align-self: center;
}

.ft-modal label {
	display: block;
    margin-top: 12px;
}

.ft-save {
	margin-top: 22px;
}

.ft-close-modal {
	position: absolute;
    right: 0;
    top: 0;
    padding: 30px 40px;
    cursor: pointer;
    font-size: 30px;
}

.ft-close-modal:hover {
	font-weight: bold;
}

.bet-button {
	height: 0!important;
    overflow: hidden;
    padding: 0;
    margin: 0;
}
`;

document.head.appendChild(style);

// also grab font awesome
let link  = document.createElement('link');
link.rel  = 'stylesheet';
link.href = 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css';
document.head.appendChild(link);